Require Import Tools.
Require Import ZArith.
Open Scope Z_scope.
Require Import List.
 Require Import Recdef.
Require Import Zwf.
Require Import Zdiv.

(** Let us consider the following declarations *)

Section Decomp.

 Variable prime : Z -> Prop.
 Hypothesis prime_1 : forall n:Z, prime n -> 2 <= n.
 Hypothesis prime_2 : forall n p q:Z,  prime n -> n = p * q -> n = p \/ n = q.

 Variable least_prime :  Z -> Z.

 Hypothesis least_prime_1 : forall n, 2 <= n -> prime(least_prime n).
 Hypothesis least_prime_2 :
     forall n, 2 <= n -> let p := least_prime n 
                         in n = p*(n/p).
 Hypothesis least_prime_3 : forall n , 2 <= n -> forall p q, prime p ->
                                       n = p*q -> least_prime n <= p.

(* question 1 :
    Define a function decomp : Z -> list Z such that
    if 1 <= n, then decomp n is a list of prime number whose product is
    equal no n 

    question 2: prove the correctness of your function *)


 
End Decomp.