
Require Import List.
Set Implicit Arguments.

Definition is_prefix_of A (u v : list A) :=
 exists w, u ++ w = v.

(* Replace the following axiom by an implementation.
   Feel free to try several approaches. *)

Parameter firstn : forall A (l:list A) n, n <= length l ->
 { l' | n = length l' /\ is_prefix_of l' l }.

Require Import ZArith.
Open Scope Z_scope.

(* Implementation of finite sets.

   We would like to precisely implement the following interface
   for sets of integers
*)

Parameter set : Type.
Parameter In : Z -> set -> Prop.
Parameter mem : forall x s, { In x s }+{ ~ In x s }.
Parameter add : forall x s, { s' | forall y, In y s' <-> y=x \/ In x s }.

(* 1) Propose an naive implementation with set := list Z *)

Inductive sorted : list Z -> Prop :=
 sorted_nil : sorted nil
| sorted_single : forall a, sorted (a::nil)
| sorted_2 : forall a b l, a <= b -> sorted (b::l) -> sorted (a::b::l).
Hint Constructors sorted.

(* 2) Implement more clever functions for set := { l : list Z | sorted l } *)

(* If you have extra time, try to implement more set operators
   (remove, inter, union, ...), or other representations of sets
   (trees,...) *)
