(* Le tableau est represent par une fonction totale 
   Comme en C, c'est a l'utilisateur de faire attention aux bornes 


   Exercice : adapter a d'autres reprsentations d'un tableau :
     type nat -> option Z

     un record contenant les indices et une fonction *)

    

Require Import ZArith.


Section Definitions.
 Definition array_t := nat -> Z.

 Variable a : array_t. (* le tableau lui meme *)

 Variable x : Z. (* l'element cherch'e *)
 

 (* position de x dans a partie du tableau a commencant en i
   et de longueur n *)

 Fixpoint search  (i n : nat)  :  option nat :=
   match n with 0 => None
              | S p =>  if  Zeq_bool x (a i) then Some i 
                                              else  search  (S i) p end .
                                 

End Definitions.

(* Tests *)

Section Tests.

Let a : array_t := fun i => let i' := Z_of_nat i in (i'*i')%Z .


Eval compute in  search a  9 0 20.

Eval compute in search a 55 0 20.

End Tests.

(* correction *)

Lemma search_1 : forall a x r n i , search a x i n =  Some r ->
                                  i <= r /\ r < i + n  /\ a(r)=x.
Proof.
 induction n.
 simpl.
  intros;discriminate.

 
  intro i; simpl;  case_eq (Zeq_bool x (a i)).
 injection 2.
 clear H0;intro;subst r.
apply Zeq_bool_eq in H.

 repeat (split;auto with arith).
 omega.
  simpl.
 intros. 
  apply IHn in H0.
 decompose [and] H0.
 clear H0.
 repeat (split;try omega).
Qed.

Lemma saerch_2 : forall a x n i, 
                               
                               search a x i n = None ->
                               forall k, i  <= k ->
                                         k < i + n ->
                                         a k <> x.
Proof.
 induction n.
 intros.
 omega.
 intro i;simpl;intros.



 case_eq (Zeq_bool x (a i)); intro H2;rewrite H2 in H.

 discriminate.
 Require Import Compare_dec.

 case (le_lt_eq_dec _ _ H0).
 intro; apply IHn with (S i);auto.
 omega.
 intro;subst k.
 apply Zeq_bool_neq in H2;auto.
Qed.

