Require Import List.
Require Import ZArith.
Require Import Tools.

(*
Fixpoint merge (u_v : list Z * list Z) : list Z :=
 match u_v with
  (nil,v) => v
| (u,nil) => u
| ((a::u')  as u,(b::v') as v) => if Zle_bool a b then a::(merge (u',v))
                              else b::(merge (u,v'))
 end.

*)

Open Scope Z_scope.

Function merge_aux (n : nat) (u v : list Z) {struct n}: list Z  :=
 match n,u,v with 0%nat,_,_ => nil
                | S _,u,nil => u
                | S _,nil,v => v
                | S p, a::u',  b::v' => 
                   if Zle_bool a b then a::(merge_aux p u' v )
                                   else b::(merge_aux p u v')
 end.

Eval vm_compute in merge_aux 45 (1::2::5::7::nil) (1::3::6::7::nil).

Eval vm_compute in merge_aux 4 (1::2::5::7::nil) (1::3::6::7::nil) .

Definition merge u v := merge_aux (length u + length v) u v .
Eval vm_compute in merge (1::2::5::7::nil) (1::3::6::7::nil) .



Fixpoint nb_occ (z:Z) (u: list Z) : nat :=
  match u with nil => 0%nat
            | p::u' => if Zeq_bool z p then S(nb_occ z u')
                                         else nb_occ z u'
  end.


Lemma nb_occ_merge_aux : forall l u v   z,  ( length u + length v <= l)%nat ->
                                nb_occ z (merge_aux  l u v ) = 
                                        (nb_occ z u + nb_occ z v)%nat.

intros l u v z;functional induction (merge_aux   l u v). 
destruct u;destruct v;simpl;auto. 
inversion 1.
inversion 1.
inversion 1.
simpl.
omega.
simpl;auto.
simpl.
case_eq (Zeq_bool z a); case_eq (Zeq_bool z b);simpl in *;intros;
rewrite H in *;
rewrite IHl0;auto.
omega.
omega.
omega.
omega.
simpl.
case_eq (Zeq_bool z a); case_eq (Zeq_bool z b);simpl in *;intros;
rewrite H0 in *;
rewrite IHl0;auto.
omega.
omega.

omega.
omega.
omega.
Qed.


Lemma nb_occ_merge : forall  u v   z,  
                                nb_occ z (merge   u v ) = 
                                        (nb_occ z u + nb_occ z v)%nat.
Proof.
 intros;unfold merge.
 apply nb_occ_merge_aux;auto with arith.   
Qed.

Inductive sorted : list Z -> Prop :=
 sorted_nil : sorted nil
| sorted_single : forall a, sorted (a::nil)
| sorted_2 : forall a b l, (a <= b)%Z -> sorted (b::l) -> sorted (a::b::l).

Hint Constructors sorted.


(* make a module of that ! *)

Open Scope Z_scope.

Lemma sorted_merge_aux : forall u v l, sorted u  -> 
                             sorted v  ->
                             sorted (merge_aux l u v ).
Proof.
 intros u v l; functional induction (merge_aux  l u v );simpl in *;auto.

(* third case *)

inversion 1;inversion 1;simpl. 

 repeat rewrite merge_aux_equation;Zbool2Prop.
  destruct p;simpl;  constructor;auto.
 repeat rewrite merge_aux_equation;Zbool2Prop. 
 destruct p;simpl;  constructor;auto.
repeat rewrite merge_aux_equation;Zbool2Prop. 
destruct p. constructor;auto.
 case_eq (Zle_bool b0 b); intro eg.
 constructor;auto.
simpl.
subst u' v'.
 rewrite merge_aux_equation in IHl0.
rewrite eg in IHl0.
apply IHl0.
inversion H;auto.
auto.
constructor 3;auto.
subst u' v'.
rewrite merge_aux_equation in IHl0.
rewrite eg in IHl0.
apply IHl0.
inversion H;auto.
auto.

subst v';subst u';rewrite merge_aux_equation in IHl0.
 rewrite merge_aux_equation.
destruct p;simpl in *.
constructor.


case_eq (Zle_bool b0 b);intro eg;rewrite eg in *.
constructor 3;auto.
constructor 3;auto.
Zbool2Prop;auto.


inversion 1;inversion 1;simpl. 

 repeat rewrite merge_aux_equation;Zbool2Prop;auto.

  destruct p;simpl;  constructor;auto.
omega.

  rewrite merge_aux_equation. 

destruct p;simpl. 
constructor;auto.

 case_eq (Zle_bool a b0).
 intro eg.
 constructor;auto.

Zbool2Prop;omega.
subst u'; subst v';auto.

rewrite merge_aux_equation in IHl0. 
rewrite eg in IHl0.
apply IHl0;auto.
subst v';subst u';rewrite merge_aux_equation in IHl0. 
intro eg; rewrite eg in IHl0.
 constructor 3;auto.
subst v';subst u';rewrite merge_aux_equation in IHl0.
rewrite merge_aux_equation.
destruct p.
constructor ;auto.
constructor 3;auto.
Zbool2Prop;omega.
 subst v';subst u';rewrite merge_aux_equation in IHl0.
case_eq (Zle_bool a b1);intro eg;rewrite eg in IHl0.
rewrite merge_aux_equation;rewrite eg.
destruct p;constructor;auto.
 Zbool2Prop;omega.

 
rewrite merge_aux_equation.
rewrite eg.  
destruct p;constructor;auto.
Qed.


Lemma sorted_merge : forall u v, sorted u -> sorted v -> sorted (merge u v).
Proof.
 intros;unfold merge;apply sorted_merge_aux;assumption.
Qed.



Extraction "merge_nat.ml" merge.



