Require Import ZArith.

Open Scope Z_scope.


Lemma Zle_false_e : forall n p, Zle_bool n p = false -> p < n.
Proof.
  intros n p e; generalize  (Zle_cases n p).
 rewrite e;auto with zarith.
Qed.

Lemma Zlt_false_e : forall n p, Zlt_bool n p = false -> p <= n.
Proof.
  intros n p e; generalize  (Zlt_cases n p).
 rewrite e;auto with zarith.
Qed.


Ltac Zbool2Prop  := repeat(
  match goal with  
 H:andb _ _ = true|-  _   => apply  Bool.andb_true_iff in H; destruct H
| H:andb _ _ = false |-  _  => apply  Bool.andb_false_elim in H; destruct H
| H:Zle_bool _ _ = true |-  _ => apply Zle_bool_imp_le in H
| H:Zeq_bool _ _ = true |-  _ => apply Zeq_bool_eq in H
| H:Zeq_bool _ _ = false |-  _ => apply Zeq_bool_neq in H
| H:Zle_bool _ _ = false |-  _ => apply Zle_false_e in H
| H:Zlt_bool _ _ = false |-  _ => apply Zlt_false_e in H
| H:Zlt_bool _ _ = true |-  _ => rewrite <- Zlt_is_lt_bool in H

 end).


Close Scope Z_scope.