Require Import ZArith.


Require Import Tools.
Open Scope Z_scope.

Require Import Zwf.
Require Import Recdef.


Function diveucl (a b:Z) (Hb: 0< b) {wf (Zwf 0) a} : Z * Z :=
  if Zlt_bool a b then (0,a)
  else let (q,r) := diveucl (a-b) b   Hb in (q+1,r).

intros.
Zbool2Prop.
split;omega.
apply Zwf_well_founded.
Defined.

Theorem div_eucl_ok : forall a b  (Hb: 0 < b)(Ha :0 <= a),
                      let (q,r) :=  diveucl a b Hb in  a = b*q+r /\ 0 <= r < b.
intros.
functional induction (diveucl a b Hb).

Show 2.


Zbool2Prop.
split;omega.
Zbool2Prop.

rewrite e0 in IHp.


destruct IHp.
omega.
split.
SearchRewrite (_ * (_ + _)).
rewrite Zmult_plus_distr_r.
omega.
assumption.
Qed.


Extraction "euclid.ml" diveucl.

