(* fonctions pour tester log10 *)

#use "log10.ml";;


let  int_to_Z n = 
  let rec aux p = if p <= 1 then XH
                  else if p mod 2 = 0 then XO (aux(p/2))
                                    else XI (aux((p-1 ) /2))
   in if n = 0 then Z0
 else if n > 0 then Zpos (aux n) else Zneg (aux (- n));;



let z_to_int n = 
  let rec pos_to_int p = match p with XH -> 1 | XO q -> 2*(pos_to_int q)
| XI q -> 1+2*(pos_to_int q)
  in 
  match n with Z0 -> 0
                | Zpos p -> pos_to_int p
                | Zneg p -> - (pos_to_int p);;

let log_10 x = z_to_int (log10 (int_to_Z x));;
